package net.seesaa.nekokiss.util;

public final class Xor128 {
	
    private int x, y, z, w;

    public Xor128(final int x, final int y, final int z, final int w) {
		this.setSeeds(x, y, z, w);
    }

    public Xor128() {
		this.setSeeds();
	}
	
	public final boolean isEmpty() {
		return (this.x | this.y | this.z | this.w) == 0;
	}
	
	public final int getX() {
		return this.x;
	}
	
	public final int getY() {
		return this.y;
	}
	
	public final int getZ() {
		return this.z;
	}
	
	public final int getW() {
		return this.w;
	}
	
	public final void setSeeds(final int x, final int y, final int z,
			final int w) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.w = w;
	}
	
	public final void setSeeds() {
        this.setSeeds(123456789, 362436069, (int)System.currentTimeMillis(),
				(int)Runtime.getRuntime().freeMemory());
	}

	public final int next() {
		return (int)this.nextL();
	}

	public final int next(final int maxValue) {
		return (int)this.nextL(0, maxValue);
	}

	public final int next(final int minValue, final int maxValue) {
		return (int)this.nextL(minValue, maxValue);
	}

    public final long nextL() {
        int t = this.x ^ (this.x << 11);
        this.x = this.y;
        this.y = this.z;
        this.z = this.w;
        this.w = (this.w ^ (this.w >>> 19)) ^ (t ^ (t >>> 8));
		//return this.w < 0 ? this.w + 0x100000000L : this.w;
		return this.w & 0xffffffffL;
    }

    public final long nextL(final long maxValue) {
        return this.nextL(0, maxValue);
    }
	
    public final long nextL(final long minValue, final long maxValue) {
        return minValue >= maxValue ? minValue : (long)(this.nextL() %
				(maxValue - minValue) + minValue);
    }
    
    public final boolean isLower(final int maxValue, final int borderValue) {
    	return this.next(maxValue) < borderValue;
    }

}
